## Deployment variants

## Application types
- command line apps bundled with other tools
- globally installed
- server application

### Snapshot
- + one file
- - needs to be shipped including the Dart executable and per platform
- - not sure it's supported
- - the user can't know what he's actually executing
- - using a newer Dart executable requires rebuilding the snapshot
> julemand101: 2015-05-20 [17:13] julemand101: my problem is my server runs Linux ARM, my dev env runs Windows and my build server runs Dart for Linux x86. This is complicated to use snapshots as a solution for easy deployment :simple_smile: 

### dart2dart
- + one file
- + just  
- - not supported
- - easier in special situations for example on ARM where it is not so easy to create new snapshots automatically (see quote from julemand101

### pub get

### pub build ( + zip)

### Docker

## Info
### Create Dart snapshot for Windows on Linux
- https://github.com/monokrome/docker-wine

## References
- Request for deployment requirements https://groups.google.com/a/dartlang.org/forum/#!topic/cloud/M538bS3xVPI 
- dep-pkgspec and packages_file package https://github.com/lrhn/dep-pkgspec

## Deployment steps (workflow)

- I assume the output should be in the `build/bin` directory, not sure thoughbecause `pub build` purges it's content but it's run after `pub build` anyway
- purge `build/bin`
- copy `bin` to `build/bin`
- determine where packages files are (`packages` directory or `.packages` file. 
- copy `packages/*` to `build/bin/packages` 
    (the `lib` directory is contained in `packages`, nothing to do here)
- optionally copy `build/web` to `build/bin/web`   
- create a `.packages` file that points to the directories in `build/bin/packages` (https://github.com/lrhn/dep-pkgspec/issues/10#issuecomment-103430554)
- optionally create a ZIP containing `build/bin` 

### Additional ideas
- write version information from `pubspec.yaml` somewhere into the source code to be available at runtime
- other pre-/post-processing steps?

- is it possible to make it self-contained?
- would it be reasonable to optionally include the Dart VM executable (would make it platform dependend)?
- what would be necessary to be added from the Dart SDK to make 'dart:xxx' imports work?
- what else to consider
